#include<bits/stdc++.h>
using namespace std;

struct node{
	int v,nxt;
}e[1000010];
int head[1000100],cnt,n,q;
void add(int u,int v){
	e[++cnt].v=v;
	e[cnt].nxt=head[u];
	head[u]=cnt;
}
int dep[1000010],f[100010][24];
void init(int u,int fa){
	dep[u]=dep[fa]+1;
	f[u][0]=fa;
	for(int i=1;i<=23;i++) f[u][i]=f[f[u][i-1]][i-1];
	for(int i=head[u];i;i=e[i].nxt){
		int v=e[i].v;
		if(v==fa) continue;
		init(v,u);
	}
}
int lca(int x,int y){
//	cout<<x<<' '<<y<<endl;
	if(dep[x]<dep[y]) swap(x,y);
	for(int i=23;i>=0;i--){
		if(dep[f[x][i]]>=dep[y]) x=f[x][i];
	}
	if(x==y) return x;
	for(int i=23;i>=0;i--){
		if(f[x][i]!=f[y][i]){
			x=f[x][i];
			y=f[y][i];
		}
	}
	return f[x][0];
}
int main(){
	ios::sync_with_stdio(0);
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	cin>>n;
	for(int i=1;i<n;i++){
		int u,v;cin>>u>>v;
		add(u,v),add(v,u);
	}
	init(1,0);
	cin>>q;
	while(q--){
		int l,r,k;cin>>l>>r>>k;
		int ans=0,t;
		if(k==1){
			for(int i=l;i<=r;i++) ans=max(ans,dep[i]);
		}
		else{
			for(int i=l;i<=r-k+1;i++){
				t=lca(i,i+1);
				for(int j=i+1;j<=i+k-2;j++){
					t=lca(t,j+1);
				}
//				cout<<l<<' '<<r<<' '<<t<<endl;
				ans=max(ans,dep[t]);
			}
		}
		
		cout<<ans<<endl;
	}
	return 0;
}
